Index: GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/src/res/levelutil/shader/ordinary.s3d_shader
===================================================================
--- GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/src/res/levelutil/shader/ordinary.s3d_shader	(revision 2499)
+++ GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/src/res/levelutil/shader/ordinary.s3d_shader	(revision 2503)
@@ -2,5 +2,5 @@
 shader_array
 {
-    name "ordinary"
+    name "ordinary_and_diffuse"
     ident "eng_shader_std.group"
     param
@@ -589,252 +589,4 @@
             }
         }
-    }
-}
-{
-    name "ordinary_diffuse"
-    ident "eng_shader_std.group"
-    param
-    {
-        env "shaderenv"
-        init_method "init_method"
-        child_array
-        {
-            ident "eng_shader_std.modelmesh"
-            param
-            {
-                env "shaderenv"
-                methods "init_method"
-                mesh_var "mesh"
-                texchan_var_array "tex0" "normalmap"
-                tex_attr_var_array "attr0"
-                usage "render"
-                tangentu_attr_var "tangentu"
-                tangentv_attr_var "tangentv"
-            }
-        }
-        {
-            ident "eng_shader_std.modelmesh"
-            param
-            {
-                env "shaderenv"
-                methods "init_method"
-                usage "shvol_occl"
-                mesh_var "mesh_shvol_occl"
-                texchan_var_array
-                tex_attr_var_array
-            }
-        }
-        {
-            ident "eng_shader_std.meshenter"
-            param
-            {
-                env "shaderenv"
-                mesh_var_array "mesh"
-                insp_ident "insp_shader_bound"
-                insp_rank 80000
-                insp_color 1.0 0.0 0.0
-                enter_array
-                {
-                    triggers "main_trigger" "mirror_trigger"
-                    method "main_method"
-                }
-                {
-                    triggers "gtp_distance_impostor_trigger"
-                    method "gtp_distance_impostor_method"
-                }
-                {
-                    triggers "gen_shmap_trigger"
-                    method "gen_shmap_method"
-                }
-                {
-                    triggers "light_trigger"
-                    method "light_method"
-                    param_array
-                    {
-                        src_extvar "ext_light_cenrange"
-                        dest_var "light_cenrange"
-                    }
-                    {
-                        src_extvar "ext_light_ambient"
-                        dest_var "light_ambient"
-                    }
-                    {
-                        src_extvar "ext_light_diffuse"
-                        dest_var "light_diffuse"
-                    }
-                    {
-                        src_extvar "ext_light_specular"
-                        dest_var "light_specular"
-                    }
-                }
-                {
-                    triggers "lightmild_trigger"
-                    method "lightmild_method"
-                    param_array
-                    {
-                        src_extvar "ext_light_cenrange"
-                        dest_var "light_cenrange"
-                    }
-                    {
-                        src_extvar "ext_light_ambient"
-                        dest_var "light_ambient"
-                    }
-                    {
-                        src_extvar "ext_light_diffuse"
-                        dest_var "light_diffuse"
-                    }
-                    {
-                        src_extvar "ext_light_specular"
-                        dest_var "light_specular"
-                    }
-                }
-                {
-                    triggers "lightbright_trigger"
-                    method "lightbright_method"
-                    param_array
-                    {
-                        src_extvar "ext_light_cenrange"
-                        dest_var "light_cenrange"
-                    }
-                    {
-                        src_extvar "ext_light_ambient"
-                        dest_var "light_ambient"
-                    }
-                    {
-                        src_extvar "ext_light_diffuse"
-                        dest_var "light_diffuse"
-                    }
-                    {
-                        src_extvar "ext_light_specular"
-                        dest_var "light_specular"
-                    }
-                    {
-                        src_extvar "ext_light_brighttex"
-                        dest_var "light_brighttex"
-                    }
-                    {
-                        src_extvar "ext_light_brightmat"
-                        dest_var "light_brightmat"
-                    }
-                }
-                {
-                    triggers "lightshmap_trigger"
-                    method "lightshmap_method"
-                    param_array
-                    {
-                        src_extvar "ext_light_cenrange"
-                        dest_var "light_cenrange"
-                    }
-                    {
-                        src_extvar "ext_light_ambient"
-                        dest_var "light_ambient"
-                    }
-                    {
-                        src_extvar "ext_light_diffuse"
-                        dest_var "light_diffuse"
-                    }
-                    {
-                        src_extvar "ext_light_specular"
-                        dest_var "light_specular"
-                    }
-                    {
-                        src_extvar "ext_light_projmat"
-                        dest_var "light_projmat"
-                    }
-                    {
-                        src_extvar "ext_light_shmapmat"
-                        dest_var "light_shmapmat"
-                    }
-                    {
-                        src_extvar "ext_light_projtex"
-                        dest_var "light_projtex"
-                    }
-                    {
-                        src_extvar "ext_light_shmap"
-                        dest_var "light_shmap"
-                    }
-                }
-                {
-                    triggers "gen_brightmap_for_softshmap_trigger"
-                    method "gen_brightmap_for_softshmap_method"
-                    param_array
-                    {
-                        src_extvar "ext_light_intens"
-                        dest_var "light_intens"
-                    }
-                    {
-                        src_extvar "ext_light_projmat"
-                        dest_var "light_projmat"
-                    }
-                    {
-                        src_extvar "ext_light_shmapmat"
-                        dest_var "light_shmapmat"
-                    }
-                    {
-                        src_extvar "ext_light_projtex"
-                        dest_var "light_projtex"
-                    }
-                    {
-                        src_extvar "ext_light_shmap"
-                        dest_var "light_shmap"
-                    }
-                }
-                {
-                    triggers "gen_brightclear_trigger"
-                    method "gen_brightclear_method"
-                }
-            }
-        }
-        {
-            ident "eng_shader_std.meshenter"
-            param
-            {
-                env "shaderenv"
-                mesh_var_array "mesh_shvol_occl"
-                insp_ident "insp_shader_bound"
-                insp_rank 80000
-                insp_color 1.0 0.0 0.0
-                enter_array
-                {
-                    triggers "shvol_mark_trigger"
-                    method "shvol_mark_method"
-                    param_array
-                    {
-                        src_extvar "ext_light_cenrange"
-                        dest_var "light_cenrange"
-                    }
-                    {
-                        src_extvar "ext_light_shvolparam"
-                        dest_var "light_shvolparam"
-                    }
-                }
-            }
-        }
-        {
-            ident "eng_shader_std.paintmesh"
-            param
-            {
-                env "shaderenv"
-                methods "main_method"
-                rank 12000
-                insp_ident "insp_shader_mesh"
-                cull_mode "back"
-                depth_test "less_equal"
-                depth_write 1
-                use_vertex_bone_wgh 1
-                use_vertex_bone_subscr 1
-                use_vertex_point 1
-                use_vertex_normal 0
-                color 0.0 0.0 0.0
-                mesh_var "mesh"
-                texchan_var_array
-                tex_attr_var_array
-                attrmat_var_array
-                lightarray_var ""
-                shaderprog_ident
-                    "levelutil/shader/prog/plain_point.s3d_shaderprog_run"
-                shaderprog_param_array
-            }
-        }
         {
             ident "gtp_shader.createtex"
@@ -1019,5 +771,5 @@
                 env "shaderenv"
                 methods "main_method"
-                rank 12000
+                rank 12100
                 insp_ident "insp_shader_mesh"
                 cull_mode "back"
@@ -1034,5 +786,5 @@
                 use_vertex_coloralpha 0
                 blend_col_src_fac "one"
-                blend_col_dest_fac "zero"
+                blend_col_dest_fac "one"
                 shaderprog_ident
                     "levelutil/shader/prog/gtp_diffuse.s3d_shaderprog_run"
@@ -1055,5 +807,5 @@
 }
 {
-    name "ordinary_caustic_receiver"
+    name "ordinary"
     ident "eng_shader_std.group"
     param
@@ -1111,17 +863,4 @@
                     triggers "gtp_distance_impostor_trigger"
                     method "gtp_distance_impostor_method"
-                }
-                {
-                    triggers "caustic_recieve_trigger"
-                    method "caustic_recieve_method"
-                    param_array
-                    {
-                        src_extvar "lastCenter"
-                        dest_var "cauCubeLastCenter"
-                    }
-                    {
-                        src_extvar "cauCubeMap"
-                        dest_var "cauCubeMap"
-                    }
                 }
                 {
@@ -1655,55 +1394,471 @@
             }
         }
-        {
-            ident "gtp_shader.worldmat"
-            param
-            {
-                env "shaderenv"
-                methods "caustic_recieve_method"
-                worldmat_var "worldMat"
-            }
-        }
-        {
-            ident "eng_shader_std.paintmesh"
-            param
-            {
-                env "shaderenv"
-                methods "caustic_recieve_method"
-                rank 14000
-                insp_ident "insp_shader_mesh"
-                cull_mode "back"
-                depth_test "less_equal"
-                depth_write 1
-                depth_bias_overlay 1
-                depth_bias_offs 1
-                mesh_var "mesh"
-                texchan_var_array "cauCubeMap"
-                tex_attr_var_array "attr0"
-                attrmat_var_array ""
-                use_vertex_bone_wgh 1
-                use_vertex_bone_subscr 1
-                use_vertex_point 1
-                blend_col_dest_fac "one"
-                blend_col_src_fac "one"
-                blend_col_op "src_plus_dest"
-                color 1.0 1.0 1.0
-                shaderprog_ident
-                    "levelutil/shader/prog/gtp_caustic_recieve.s3d_shaderprog_"
-                    & "run"
-                shaderprog_param_array
-                {
-                    src_var "cauCubeLastCenter"
-                    dest_progvar "lastCenter"
-                }
-                {
-                    src_var "worldMat"
-                    dest_progvar "worldMat"
-                }
-            }
-        }
     }
 }
 {
-    name "ordinary_copper"
+    name "ordinary_diffuse"
+    ident "eng_shader_std.group"
+    param
+    {
+        env "shaderenv"
+        init_method "init_method"
+        child_array
+        {
+            ident "eng_shader_std.modelmesh"
+            param
+            {
+                env "shaderenv"
+                methods "init_method"
+                mesh_var "mesh"
+                texchan_var_array "tex0" "normalmap"
+                tex_attr_var_array "attr0"
+                usage "render"
+                tangentu_attr_var "tangentu"
+                tangentv_attr_var "tangentv"
+            }
+        }
+        {
+            ident "eng_shader_std.modelmesh"
+            param
+            {
+                env "shaderenv"
+                methods "init_method"
+                usage "shvol_occl"
+                mesh_var "mesh_shvol_occl"
+                texchan_var_array
+                tex_attr_var_array
+            }
+        }
+        {
+            ident "eng_shader_std.meshenter"
+            param
+            {
+                env "shaderenv"
+                mesh_var_array "mesh"
+                insp_ident "insp_shader_bound"
+                insp_rank 80000
+                insp_color 1.0 0.0 0.0
+                enter_array
+                {
+                    triggers "main_trigger" "mirror_trigger"
+                    method "main_method"
+                }
+                {
+                    triggers "gtp_distance_impostor_trigger"
+                    method "gtp_distance_impostor_method"
+                }
+                {
+                    triggers "gen_shmap_trigger"
+                    method "gen_shmap_method"
+                }
+                {
+                    triggers "light_trigger"
+                    method "light_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                }
+                {
+                    triggers "lightmild_trigger"
+                    method "lightmild_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                }
+                {
+                    triggers "lightbright_trigger"
+                    method "lightbright_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                    {
+                        src_extvar "ext_light_brighttex"
+                        dest_var "light_brighttex"
+                    }
+                    {
+                        src_extvar "ext_light_brightmat"
+                        dest_var "light_brightmat"
+                    }
+                }
+                {
+                    triggers "lightshmap_trigger"
+                    method "lightshmap_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                    {
+                        src_extvar "ext_light_projmat"
+                        dest_var "light_projmat"
+                    }
+                    {
+                        src_extvar "ext_light_shmapmat"
+                        dest_var "light_shmapmat"
+                    }
+                    {
+                        src_extvar "ext_light_projtex"
+                        dest_var "light_projtex"
+                    }
+                    {
+                        src_extvar "ext_light_shmap"
+                        dest_var "light_shmap"
+                    }
+                }
+                {
+                    triggers "gen_brightmap_for_softshmap_trigger"
+                    method "gen_brightmap_for_softshmap_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_intens"
+                        dest_var "light_intens"
+                    }
+                    {
+                        src_extvar "ext_light_projmat"
+                        dest_var "light_projmat"
+                    }
+                    {
+                        src_extvar "ext_light_shmapmat"
+                        dest_var "light_shmapmat"
+                    }
+                    {
+                        src_extvar "ext_light_projtex"
+                        dest_var "light_projtex"
+                    }
+                    {
+                        src_extvar "ext_light_shmap"
+                        dest_var "light_shmap"
+                    }
+                }
+                {
+                    triggers "gen_brightclear_trigger"
+                    method "gen_brightclear_method"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.meshenter"
+            param
+            {
+                env "shaderenv"
+                mesh_var_array "mesh_shvol_occl"
+                insp_ident "insp_shader_bound"
+                insp_rank 80000
+                insp_color 1.0 0.0 0.0
+                enter_array
+                {
+                    triggers "shvol_mark_trigger"
+                    method "shvol_mark_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_shvolparam"
+                        dest_var "light_shvolparam"
+                    }
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                rank 12000
+                insp_ident "insp_shader_mesh"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 1
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 0
+                color 0.0 0.0 0.0
+                mesh_var "mesh"
+                texchan_var_array
+                tex_attr_var_array
+                attrmat_var_array
+                lightarray_var ""
+                shaderprog_ident
+                    "levelutil/shader/prog/plain_point.s3d_shaderprog_run"
+                shaderprog_param_array
+            }
+        }
+        {
+            ident "gtp_shader.createtex"
+            param
+            {
+                env "shaderenv"
+                methods "init_method"
+                texchan_var "envmap0"
+                width 128
+                height 128
+                texprop_rendertarget 1
+                texprop_cube 1
+                texprop_float 0
+                texprop_comp 4
+                texprop_bitspercomp 8
+                samplermode_clamp 0
+                samplermode_filter 1
+            }
+        }
+        {
+            ident "gtp_shader.envmap"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                rank -9000
+                max_ext 256
+                max_recursion 1
+                ext_dist_scale 20.0
+                proj_neg_z 0.1
+                proj_pos_z 100.0
+                enum_trigger "mirror_trigger"
+                destprop_antialias 0
+                mesh_var "mesh"
+                update_interval 12
+                update_all_face 0
+                start_frame 0
+                last_center_var "lastCenter"
+                world_space 1
+                dest_array
+                {
+                    from_var "envmap0"
+                    to_var "envmap0"
+                    texprop_restrusage 0
+                    texprop_depth 0
+                    texprop_comp 3
+                    texprop_float 0
+                    samplermode_filter 0
+                    samplermode_clamp 1
+                }
+            }
+        }
+        {
+            ident "gtp_shader.createtex"
+            param
+            {
+                env "shaderenv"
+                methods "init_method"
+                texchan_var "dist"
+                width 128
+                height 128
+                texprop_rendertarget 1
+                texprop_cube 1
+                texprop_float 1
+                texprop_comp 2
+                texprop_bitspercomp 16
+                samplermode_clamp 0
+                samplermode_filter 0
+            }
+        }
+        {
+            ident "gtp_shader.envmap"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                rank -9000
+                max_ext 128
+                max_recursion 1
+                ext_dist_scale 20.0
+                proj_neg_z 0.1
+                proj_pos_z 100.0
+                enum_trigger "gtp_distance_impostor_trigger"
+                destprop_antialias 0
+                mesh_var "mesh"
+                update_interval 1
+                update_all_face 1
+                start_frame 0
+                last_center_var ""
+                world_space 1
+                dest_array
+                {
+                    from_var "dist"
+                    to_var "dist"
+                    texprop_restrusage 0
+                    texprop_depth 0
+                    texprop_comp 1
+                    texprop_float 1
+                    samplermode_filter 0
+                    samplermode_clamp 1
+                }
+            }
+        }
+        {
+            ident "gtp_shader.createtex"
+            param
+            {
+                env "shaderenv"
+                methods "init_method"
+                texchan_var "filteredenvmap"
+                width 4
+                height 4
+                texprop_rendertarget 1
+                texprop_cube 1
+                texprop_float 0
+                texprop_comp 4
+                texprop_bitspercomp 8
+                samplermode_clamp 0
+                samplermode_filter 1
+            }
+        }
+        {
+            ident "gtp_shader.cubetexfilter"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                rank -8000
+                iter_start 0
+                iter_end 0
+                iter_step 0
+                width_scale 1.0
+                height_scale 1.0
+                destprop_antialias 0
+                passinfo_var ""
+                src_array "envmap0"
+                update_interval 1
+                dest_array
+                {
+                    from_var "filteredenvmap"
+                    to_var "filteredenvmap"
+                    texprop_restrusage 0
+                    texprop_depth 0
+                    texprop_float 0
+                    texprop_comp 4
+                    texprop_bitspercomp 0
+                    samplermode_filter 1
+                    samplermode_clamp 1
+                }
+                shaderprog_ident
+                    "levelutil/shader/prog/gtp_reduce_cubemap.s3d_shaderprog_r"
+                    & "un"
+                shaderprog_param_array
+                {
+                }
+            }
+        }
+        {
+            ident "gtp_shader.worldmat"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                worldmat_var "worldMat"
+            }
+        }
+        {
+            ident "gtp_shader.worldmat"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                worldmat_var "worldMatIT"
+                inverse 1
+                transpose 1
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                rank 12000
+                insp_ident "insp_shader_mesh"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 0
+                mesh_var "mesh"
+                texchan_var_array "filteredenvmap" "dist"
+                tex_attr_var_array "attr0"
+                attrmat_var_array ""
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 1
+                use_vertex_coloralpha 0
+                blend_col_src_fac "one"
+                blend_col_dest_fac "one"
+                shaderprog_ident
+                    "levelutil/shader/prog/gtp_diffuse.s3d_shaderprog_run"
+                shaderprog_param_array
+                {
+                    src_var "lastCenter"
+                    dest_progvar "lastCenter"
+                }
+                {
+                    src_var "worldMat"
+                    dest_progvar "worldMat"
+                }
+                {
+                    src_var "worldMatIT"
+                    dest_progvar "worldMatIT"
+                }
+            }
+        }
+    }
+}
+{
+    name "ordinary_caustic_receiver"
     ident "eng_shader_std.group"
     param
@@ -1761,4 +1916,17 @@
                     triggers "gtp_distance_impostor_trigger"
                     method "gtp_distance_impostor_method"
+                }
+                {
+                    triggers "caustic_recieve_trigger"
+                    method "caustic_recieve_method"
+                    param_array
+                    {
+                        src_extvar "lastCenter"
+                        dest_var "cauCubeLastCenter"
+                    }
+                    {
+                        src_extvar "cauCubeMap"
+                        dest_var "cauCubeMap"
+                    }
                 }
                 {
